原创

docker安装和使用

一、安装

特别注意: 因为docker 的镜像与容器都存储在 /var/lib/docker下,为避免后续安装问题,安装操作系统时应给/var文件夹或者根目录/尽可能大的存储空间!!!

1.1、先安装docker

若先前有安装docker需要先卸载(若没有安装过则无需执行),执行命令:

sudo apt-get remove docker docker-engine docker.io

Docker的安装有多个方式,这里以最常见的方式为例。首先依次执行以下命令(反斜杠\代表一行,只是换行写更清晰),把docker仓库加进到apt里:

然后正式安装docker:

sudo apt-get update

sudo apt-get install docker-ce

apt-cache madison docker-ce

sudo docker run hello-world

最后一个命令是验证docker是否安装成功,它会下载并执行hello-world镜像。如果安装正确,应该可以正确执行。

1.2、nviida-docker的安装

之前若安装nvidia需要先卸载

安装:

命令1:wget -P /tmphttps://github.com/NVIDIA/nvidia-docker/releases/download/v1.0.1/nvidia-docker_1.0.1-1_amd64.deb

命令2:wget -P /tmp https://github.com/NVIDIA/nvidia-docker/releases/download/v1.0.1/nvidia-docker_1.0.1-1_amd64.deb

sudo dpkg -i /tmp/nvidia-docker*.deb && rm /tmp/nvidia-docker*.deb

测试:

sudo nvidia-docker run --rm nvidia/cuda:9.0-devel  nvidia-smi

1.3报错:

docker容器启动报错:

docker: Error response from daemon: OCI runtime create failed: container_linux.go:344: starting container process caused "process_linux.go:297: getting the final child's pid from pipe caused \"read init-p: connection reset by peer\"": unknown.

原因:docker版本过高,内核版本过低造成。

解决办法:降低docker版本或升级内核版本。已知yum安装的docker-18.09 与系统内核3.10版本不符,容器启动失败,或者:

sudo nvidia-docker run --rm nvidia/cuda:8.0-devel nvidia-smi

注意:安装好nvidia-docker之后,之后的docker需要用nvidia-docker代替,除非指定用docker代替nvidia-docker,即之后的镜像都需要nvidia-docker来启动,或者docker run --runtime=nvidia即可。

(替换:如果你想用docker取代nvidia-docker可以修改/etc/docker/daemon.json为如下所示,即在第一行加入"default-runtime": "nvidia",这样就可以直接用docker取代nvidia-docker了。)

三、使用

systemctl status nvidia-docker(检查是否启动)

systemctl start nvidia-docker (重启docker服务)

systemctl status nvidia-docker

四、运行

sudo docker cp host_path containerID:container_path(宿主机和容器间复制文件,注意:在要复制文件的父目录下打开命令比如:sudo docker cp /home/ccy/Ruanjian/Anaconda3-4.2.0-Linux-x86_64.sh  30f095f5923e:/root/conda-install)

sudo nvidia-docker run --env LANG=C.UTF-8 -p 8080:8080 -itd -v /home/ccy/ocr:/home/ocr cy247706243/ocr

开机自启:sudo nvidia-docker run --env LANG=C.UTF-8 -p 8080:8080   --privileged=true  --restart=always  -itd   cy247706243/ocrdetect  /home/detect/auto.sh

当前可实现的开机自启:sudo nvidia-docker run --env LANG=C.UTF-8 -p 8080:8080 --privileged=true --restart=always -it cy247706243/ocrdetect  /bin/bash -i -c "/home/ocr.sh"

注意:当前也能利用restart=alawaws  实现开机自启,即使停止容器情况下,但是一定要执行完上诉语句后重启一遍电脑!!!

五、保存和发布

1.先用ctrl+p+q退出已修改的容器(或者使用docker commit时带-p参数让容器暂停)

2.再来发布已经修改的镜像:docker commit ID (镜像名称)

3.如果要把镜像保存在本地,可用docker save/export 把镜像导出来

3.1运行sudo docker save -o /home/ccy/hub/ocr.tar cy247706243/ocr

可以把镜像保存在本地,其中 /home/ccy/hub/是路径,ocr.tar是保存的文件名,cy247706243/ocr是镜像名

相应的导入运行sudo docker load -i /home/ccy/hub/ocr.tar 即指定路径和文件名

4.也可以把镜像push到hub官网上,便于下载和部署

4.1首先运行sudo docker login 登录hub官网,

4.2然后对镜像用sudo docker tag ID  名称进行命名(要带hub登录名cy247706243),如:sudo docker tag  ID  cy247706243/ocr:latest(:latest为tag可以不指定,默认为latest)

4.3再进行推送sudo docker push cy247706243/ocr:latest   等待推送完成即可

六、报错

UnicodeEncodeError: 'ascii' codec can't encode character '\u4e0e' in position 0: ordinal not in range(128)

是因为python在安装时,默认的编码是ascii,当程序中出现非ascii编码时,python的处理常常会报这样的错,python没办法处理非ascii编码的,此时需要自己设置将python的默认编码,一般设置为utf8的编码格式。

设置容器的环境变量, --env LANG=C.UTF-8

原创声明,本文系作者授权云+社区发表,未经许可,不得转载。

如有侵权,请联系 yunjia_community@tencent.com 删除。

我来说两句

0 条评论
登录 后参与评论

相关文章

  • docker离线安装

    参考:https://www.cnblogs.com/atuotuo/p/9272368.html

    用户7625592
  • ubantu系统输入法加NVIIDIA+cuda

    双系统win10+ubantu系统卸载ubantu:首先应知道自己的电脑分区格式(自行百度GBT和MBR分区)。

    用户7625592
  • opencv报错

    错误一:error: (-215) !empty() in function cv::CascadeClassifier::detectMultiScale

    用户7625592
  • Docker常用命令

    学习Docker有段时间了,所有的操作都是在命令行下,如果不是每天都在使用,很容易忘记命令。本文将以学习Docker的角度,从前到后,将一些常用的Docker命...

    oec2003
  • 快速学习Docker-Docker基本概念与安装

    版权声明:本文为博主原创文章,遵循 CC 4.0 BY-SA 版权协议,转载请附上原文出处链接和本声明。 ...

    cwl_java
  • docker创建进入删除容器资源限制

    陈雷雷
  • Docker从入门到掉坑(二):基于Docker构建SpringBoot微服务

    在之前的文章里面介绍了如何基于docker容器部署一些常见的基础环境,例如MySQL、Redis这些,那么这篇文章里面我会介绍一些关于SpringBoot如何打...

    乔戈里
  • Docker入门指南

    Tanyboye
  • 002.Docker安装部署

    Delta RPMs disabled because /usr/bin/yum provides applydeltarpmnot installed.

    木二
  • Deepin20安装docker

    deepin 属于 debain 系,跟 Ubuntu 相似,由国人开发。现在作为我的主力开发环境,使用下来还不错,虽不如 windows, mac 的整体流...

    caoayu

扫码关注云+社区

领取腾讯云代金券